package com.steerinfo.dil.controller;

import com.alibaba.fastjson.JSON;
import com.steerinfo.dil.feign.ColumnDataFeign;
import com.steerinfo.dil.feign.ESFeign;
import com.steerinfo.dil.model.TmstrainWagonUnloadResult;
import com.steerinfo.dil.service.ITmstrainWagonUnloadResultService;
import com.steerinfo.dil.util.ColumnDataUtil;
import com.steerinfo.dil.util.PageListAdd;
import com.steerinfo.dil.util.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageHelper;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.math.BigDecimal;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * TmstrainWagonUnloadResult RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2021-08-19 09:22
 * 类描述
 * 修订历史：
 * 日期：2021-08-19
 * 作者：generator
 * 参考：
 * 描述：TmstrainWagonUnloadResult RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/tmstrainwagonunloadresults")
public class TmstrainWagonUnloadResultController extends BaseRESTfulController {

    @Autowired
    ITmstrainWagonUnloadResultService tmstrainWagonUnloadResultService;

    @Autowired
    ColumnDataFeign columnDataFeign;

    @Autowired
    ColumnDataUtil columnDataUtil;

    @Autowired
    ESFeign esFeign;

    @ApiOperation(value = "查询卸车作业信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId(60)", value = "表头", required = false, dataType = "Interger")
    })
    @PostMapping("/getTmstrainWagonUnLoad")
    public RESTfulResult getTmstrainWagonUnLoad(@RequestBody(required = false) Map<String, Object> mapValue,
                                                Integer apiId,
                                                Integer pageNum,
                                                Integer pageSize,
                                                Integer resultType,
                                                String con) {
        if (con != null) {
            if (!"undefined".equals(con)) {
                //设置要查询的索引名称
                String index = "get_train_wagon_unload";
                //获取查询结果
                return success(esFeign.getConResult(mapValue, index, apiId, pageNum, pageSize, con));
            }
        }
        //初始化过滤
        List<Map<String, Object>> wagonUnloadList = null;
        mapValue.put("resultType", resultType);
        //如果有条件查询则跳过初始化，和创建索引
        if (mapValue.size() == 1) {
            //将查询结果存入索引中
            wagonUnloadList = tmstrainWagonUnloadResultService.getTmstrainWagonUnLoad(mapValue);
            Map<String, Object> map = new HashMap<>();
            //添加索引
            map.put("index", "get_train_wagon_unload");
            //添加id
            map.put("indexId", "resultId6");
            wagonUnloadList.add(map);
            //新建索引
            String s = JSON.toJSONString(wagonUnloadList);
            esFeign.insertIndex(wagonUnloadList);
            //删除
            wagonUnloadList.remove(wagonUnloadList.size() - 1);
        }
        if (wagonUnloadList == null) {
            wagonUnloadList = tmstrainWagonUnloadResultService.getTmstrainWagonUnLoad(mapValue);
        }
        PageHelper.startPage(pageNum, pageSize);
        List<Map<String, Object>> tmstrainWagonUnLoad1 = tmstrainWagonUnloadResultService.getTmstrainWagonUnLoad(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, wagonUnloadList, tmstrainWagonUnLoad1);
        return success(pageList);
    }

    /**
     * 通过主键删除车皮卸车作业实绩
     *
     * @param unloadingId
     * @return
     */
    @ApiOperation(value = "通过主键删除车皮卸车作业实绩")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "unloadingId", value = "主键ID", required = false, dataType = "BigDecimal")
    })
    @PostMapping(value = "/deleteTmstrainWagonUnLoadResultByUnLoadingId")
    public RESTfulResult deleteTmstrainWagonUnLoadResultByUnLoadingId(@RequestParam BigDecimal unloadingId) {
        int i = tmstrainWagonUnloadResultService.deleteTmstrainWagonUnLoadResultByUnLoadingId(unloadingId);
        return success(i);
    }

    /**
     * 新增车皮卸车作业实绩
     *
     * @param tmstrainWagonUnloadResult
     * @return
     */
    @ApiOperation(value = "新增车皮卸车作业实绩")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "tmstrainWagonUnloadResult", value = "车皮卸车对象", required = false, dataType = "TmstrainWagonUnloadResult")
    })
    @PostMapping(value = "/insertTmstrainWagonUnLoadResult")
    public RESTfulResult insertTmstrainWagonUnLoadResult(@RequestBody(required = false) TmstrainWagonUnloadResult tmstrainWagonUnloadResult, Integer orderType) {
        int i = tmstrainWagonUnloadResultService.insertTmstrainWagonUnLoadResult(tmstrainWagonUnloadResult);
        return success(i);
    }

    /**
     * 通过主键修改车皮卸车作业实绩
     *
     * @param tmstrainWagonUnloadResult
     * @return
     */
    @ApiOperation(value = "通过主键修改车皮卸车作业实绩")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "tmstrainWagonUnloadResult", value = "车皮卸车对象", required = false, dataType = "TmstrainWagonUnloadResult")
    })
    @PostMapping(value = "/upadteTmstrainWagonUnLoadResultByUnLoadingId")
    public RESTfulResult upadteTmstrainWagonUnLoadResultByUnLoadingId(@RequestBody(required = false) TmstrainWagonUnloadResult tmstrainWagonUnloadResult) {
        System.out.println(tmstrainWagonUnloadResult);
        int i = tmstrainWagonUnloadResultService.updateTmstrainWagonUnLoadResult(tmstrainWagonUnloadResult);
        return success(i);
    }

    @ApiOperation(value = "查看火运实绩")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId(65)", value = "表头", required = false, dataType = "Interger")
    })
    @PostMapping("/getTmstrainresult")
    public RESTfulResult getTmstrainresult(@RequestBody(required = false) Map<String, Object> mapValue,
                                           Integer apiId,
                                           Integer pageNum,
                                           Integer pageSize,
                                           String con) {
        if (con != null) {
            if (!"undefined".equals(con)) {
                //设置要查询的索引名称
                String index = "get_tmstrain_result";
                //获取查询结果
                return success(esFeign.getConResult(mapValue, index, apiId, pageNum, pageSize, con));
            }
        }
        //初始化过滤
        List<Map<String, Object>> tmstrainList = null;
        //如果有条件查询则跳过初始化，和创建索引
        if (mapValue == null) {
            //将查询结果存入索引中
            tmstrainList = tmstrainWagonUnloadResultService.getTmstrainResult(null);
            Map<String, Object> map = new HashMap<>();
            //添加索引
            map.put("index", "get_tmstrain_result");
            //添加id
            map.put("indexId", "result7");
            tmstrainList.add(map);
            //新建索引
            String s = JSON.toJSONString(tmstrainList);
            esFeign.insertIndex(tmstrainList);
            //删除
            tmstrainList.remove(tmstrainList.size() - 1);
        }
        if (tmstrainList == null) {
            tmstrainList = tmstrainWagonUnloadResultService.getTmstrainResult(mapValue);
        }
        PageHelper.startPage(pageNum, pageSize);
        List<Map<String, Object>> tmstrainResult1 = tmstrainWagonUnloadResultService.getTmstrainResult(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, tmstrainList, tmstrainResult1);
        return success(pageList);
    }

    /**
     * 获取卸车地点名称
     *
     * @param
     * @return
     */
    @ApiOperation(value = "获取卸车地点名称")
    @ApiImplicitParams({
    })
    @GetMapping(value = "/getUnloadingPointName")
    public RESTfulResult getUnloadingPointName() {

        return success(tmstrainWagonUnloadResultService.getUnloadingPointName());
    }

    /**
     * 获取卸车路径名称
     *
     * @param
     * @return
     */
    @ApiOperation(value = "获取卸车路径名称")
    @ApiImplicitParams({
    })
    @GetMapping(value = "/getUnloadingRouteName")
    public RESTfulResult getUnloadingRouteName() {
        return success(tmstrainWagonUnloadResultService.getUnloadingRouteName());
    }

    /**
     * 通过主键查询车皮卸车作业信息
     *
     * @param unloadingId
     * @return
     */
    @ApiOperation(value = "通过主键查询车皮卸车作业信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "unloadingId", value = "车皮卸车主键", required = false, dataType = "BigDecimal")
    })
    @PostMapping(value = "/getTmstrainWagonUnLoadResultByUnLoadingId/{unloadingId}")
    public RESTfulResult getTmstrainWagonUnLoadResultByUnLoadingId(@PathVariable("unloadingId") BigDecimal unloadingId, Integer orderType) {
        List<Map<String, Object>> mes = tmstrainWagonUnloadResultService.getTmstrainWagonUnLoadResultByUnLoadingId(unloadingId);
        return success(mes);
    }

    //********内转实绩**************************************
    @ApiOperation(value = "内转新增卸车实绩")
    @ApiImplicitParams({
    })
    @PostMapping(value = "/addTmsTrainUnloadResultForNZ")
    public RESTfulResult addTmsTrainUnloadResultForNZ(@RequestBody(required = false)Map<String, Object> map) {
        int i = tmstrainWagonUnloadResultService.addTmsTrainUnloadResultForNZ(map);
        return success(i);
    }


    //*********内转物流查询火车卸车实绩************************************
    @ApiOperation(value = "查询火车卸车信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId(202)", value = "表头", required = false, dataType = "Interger")
    })
    @PostMapping("/selectTrainUnLoadResultForConverted")
    public RESTfulResult selectTrainUnLoadResultForConverted(@RequestBody(required = false) Map<String, Object> mapValue,
                                                             Integer apiId,
                                                             Integer pageNum,
                                                             Integer pageSize,
                                                             String con) {
        if (con != null) {
            if (!"undefined".equals(con)) {
                //设置要查询的索引名称
                String index = "wagon_unload_result";
                //获取查询结果
                return success(esFeign.getConResult(mapValue, index, apiId, pageNum, pageSize, con));
            }
        }
        //初始化过滤
        List<Map<String, Object>> trainUnLoadResult = null;
        //如果有条件查询则跳过初始化，和创建索引
        if (mapValue.size() == 0) {
            //将查询结果存入索引中
            trainUnLoadResult = tmstrainWagonUnloadResultService.getTmstrainResult(null);
            Map<String, Object> map = new HashMap<>();
            //添加索引
            map.put("index", "wagon_unload_result");
            //添加id
            map.put("indexId", "result8");
            trainUnLoadResult.add(map);
            //新建索引
            String s = JSON.toJSONString(trainUnLoadResult);
            esFeign.insertIndex(trainUnLoadResult);
            //删除
            trainUnLoadResult.remove(trainUnLoadResult.size() - 1);
        }
        if (trainUnLoadResult == null) {
            trainUnLoadResult = tmstrainWagonUnloadResultService.getTmstrainResult(mapValue);
        }
        PageHelper.startPage(pageNum, pageSize);
        List<Map<String, Object>> tmstrainWagonUnLoad1 = tmstrainWagonUnloadResultService.getTmstrainResult(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, trainUnLoadResult, tmstrainWagonUnLoad1);
        return success(pageList);
    }


}
