package com.steerinfo.dil.model;

import com.baomidou.mybatisplus.annotation.TableField;
import com.steerinfo.framework.model.IBasePO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.Map;

@ApiModel(value="车皮卸车作业")
public class TmstrainWagonUnloadResult implements IBasePO<BigDecimal> {
    /**
     * 主键ID(UNLOADING_ID,DECIMAL,0)
     */
    @ApiModelProperty(value="主键ID",required=true)
    private BigDecimal unloadingId;

    /**
     * 采购订单ID/发运计划ID(PURCHASE_ORDER_RAIL_PLAN_ID,DECIMAL,0)
     */
    @ApiModelProperty(value="采购订单ID/发运计划ID",required=false)
    private BigDecimal purchaseOrderRailPlanId;

    /**
     * 车皮号(RESULT_WAGON_NO,VARCHAR,20)
     */
    @ApiModelProperty(value="车皮号",required=false)
    private String resultWagonNo;

    /**
     * 到达日期(RESULT_ARRIVAL_DATE,TIMESTAMP,7)
     */
    @ApiModelProperty(value="到达日期",required=false)
    private Date resultArrivalDate;

    /**
     * 卸车日期(RESULT_UNLOAD_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="卸车日期",required=false)
    private Date resultUnloadTime;

    /**
     * 卸车地点(UNLOADING_POINT_ID,DECIMAL,0)
     */
    @ApiModelProperty(value="卸车地点",required=false)
    private BigDecimal unloadingPointId;

    /**
     * 大票重量(RESULT_BIG_TICKET_WEIGHT,DECIMAL,0)
     */
    @ApiModelProperty(value="大票重量",required=false)
    private BigDecimal resultBigTicketWeight;

    /**
     * 轨道衡重量(RESULT_RAIL_HORIZONTAL_WEIGHT,DECIMAL,0)
     */
    @ApiModelProperty(value="轨道衡重量",required=false)
    private BigDecimal resultRailHorizontalWeight;

    /**
     * 备注(RESULT_REMARK,VARCHAR,20)
     */
    @ApiModelProperty(value="备注",required=false)
    private String resultRemark;

    /**
     * 记录创建人(INSERT_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录创建人",required=false)
    private String insertUsername;

    /**
     * 记录创建时间(INSERT_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录创建时间",required=false)
    private Date insertTime;

    /**
     * 记录修改人(UPDATE_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录修改人",required=false)
    private String updateUsername;

    /**
     * 记录修改时间(UPDATE_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录修改时间",required=false)
    private Date updateTime;

    /**
     * 记录创建或修改备注(INSERT_UPDATE_REMARK,VARCHAR,100)
     */
    @ApiModelProperty(value="记录创建或修改备注",required=false)
    private String insertUpdateRemark;

    /**
     * 是否删除（0:否, 1:是）(DELETED,DECIMAL,0)
     */
    @ApiModelProperty(value="是否删除（0:否, 1:是）",required=false)
    private BigDecimal deleted;

    /**
     * 卸车类型：1：采购进口矿（万州港-达州站/万州港-老区轨道衡）2：采购进口矿（海港-老区轨道衡）3：采购国产矿 4：内转(RESULT_TYPE,DECIMAL,0)
     */
    @ApiModelProperty(value="卸车类型：1：采购进口矿（万州港-达州站/万州港-老区轨道衡）2：采购进口矿（海港-老区轨道衡）3：采购国产矿 4：内转",required=false)
    private BigDecimal resultType;

    /**
     * 车皮号列表
     */
    @TableField(exist = false)
    @ApiModelProperty(value = "车皮号列表")
    private List<Map<String, Object>> wagonNoList;
    private static final long serialVersionUID = 1L;

    @Override
    public BigDecimal getId() {
        return this.unloadingId;
    }

    @Override
    public void setId(BigDecimal unloadingId) {
        this.unloadingId = unloadingId;
    }

    public BigDecimal getUnloadingId() {
        return unloadingId;
    }

    public void setUnloadingId(BigDecimal unloadingId) {
        this.unloadingId = unloadingId;
    }

    public BigDecimal getPurchaseOrderRailPlanId() {
        return purchaseOrderRailPlanId;
    }

    public void setPurchaseOrderRailPlanId(BigDecimal purchaseOrderRailPlanId) {
        this.purchaseOrderRailPlanId = purchaseOrderRailPlanId;
    }

    public String getResultWagonNo() {
        return resultWagonNo;
    }

    public void setResultWagonNo(String resultWagonNo) {
        this.resultWagonNo = resultWagonNo == null ? null : resultWagonNo.trim();
    }

    public Date getResultArrivalDate() {
        return resultArrivalDate;
    }

    public void setResultArrivalDate(Date resultArrivalDate) {
        this.resultArrivalDate = resultArrivalDate;
    }

    public Date getResultUnloadTime() {
        return resultUnloadTime;
    }

    public void setResultUnloadTime(Date resultUnloadTime) {
        this.resultUnloadTime = resultUnloadTime;
    }

    public BigDecimal getUnloadingPointId() {
        return unloadingPointId;
    }

    public void setUnloadingPointId(BigDecimal unloadingPointId) {
        this.unloadingPointId = unloadingPointId;
    }

    public BigDecimal getResultBigTicketWeight() {
        return resultBigTicketWeight;
    }

    public void setResultBigTicketWeight(BigDecimal resultBigTicketWeight) {
        this.resultBigTicketWeight = resultBigTicketWeight;
    }

    public BigDecimal getResultRailHorizontalWeight() {
        return resultRailHorizontalWeight;
    }

    public void setResultRailHorizontalWeight(BigDecimal resultRailHorizontalWeight) {
        this.resultRailHorizontalWeight = resultRailHorizontalWeight;
    }

    public String getResultRemark() {
        return resultRemark;
    }

    public void setResultRemark(String resultRemark) {
        this.resultRemark = resultRemark == null ? null : resultRemark.trim();
    }

    public String getInsertUsername() {
        return insertUsername;
    }

    public void setInsertUsername(String insertUsername) {
        this.insertUsername = insertUsername == null ? null : insertUsername.trim();
    }

    public Date getInsertTime() {
        return insertTime;
    }

    public void setInsertTime(Date insertTime) {
        this.insertTime = insertTime;
    }

    public String getUpdateUsername() {
        return updateUsername;
    }

    public void setUpdateUsername(String updateUsername) {
        this.updateUsername = updateUsername == null ? null : updateUsername.trim();
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public String getInsertUpdateRemark() {
        return insertUpdateRemark;
    }

    public void setInsertUpdateRemark(String insertUpdateRemark) {
        this.insertUpdateRemark = insertUpdateRemark == null ? null : insertUpdateRemark.trim();
    }

    public BigDecimal getDeleted() {
        return deleted;
    }

    public void setDeleted(BigDecimal deleted) {
        this.deleted = deleted;
    }

    public BigDecimal getResultType() {
        return resultType;
    }

    public void setResultType(BigDecimal resultType) {
        this.resultType = resultType;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", unloadingId=").append(unloadingId);
        sb.append(", purchaseOrderRailPlanId=").append(purchaseOrderRailPlanId);
        sb.append(", resultWagonNo=").append(resultWagonNo);
        sb.append(", resultArrivalDate=").append(resultArrivalDate);
        sb.append(", resultUnloadTime=").append(resultUnloadTime);
        sb.append(", unloadingPointId=").append(unloadingPointId);
        sb.append(", resultBigTicketWeight=").append(resultBigTicketWeight);
        sb.append(", resultRailHorizontalWeight=").append(resultRailHorizontalWeight);
        sb.append(", resultRemark=").append(resultRemark);
        sb.append(", insertUsername=").append(insertUsername);
        sb.append(", insertTime=").append(insertTime);
        sb.append(", updateUsername=").append(updateUsername);
        sb.append(", updateTime=").append(updateTime);
        sb.append(", insertUpdateRemark=").append(insertUpdateRemark);
        sb.append(", deleted=").append(deleted);
        sb.append(", resultType=").append(resultType);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }

    public List<Map<String, Object>> getWagonNoList() {
        return wagonNoList;
    }

    public void setWagonNoList(List<Map<String, Object>> wagonNoList) {
        this.wagonNoList = wagonNoList;
    }
}